Draft PathArray/de: Difference between revisions

From FreeCAD Documentation
(Created page with "{{Caption|Objekt, das entlang eines geschlossenen Pfades in der ursprünglichen Ausrichtung angeordnet ist.}}")
(Created page with "Um Kopien in einem orthogonalen Anordnung zu positionieren, verwende Entwurf Anordnung; um Kopien an bestimmten Punkten zu positionieren, verwende Draft P...")
Line 16: Line 16:
Das PathArray Werkzeug kann auf 2D Formen verwendet werden, die mit der [[Draft Workbench/de|Entwurf Arbeitsbereich]] erstellt wurden, aber auch auf vielen Arten von 3D-Objekten, wie sie mit der [[Part Workbench/de|Part Arbeitsbereich]], [[PartDesign Workbench/de|PartDesign Arbeitsbereich]] oder [[Arch Workbench/de|Arch Arbeitsbereich]]en erstellt wurden.
Das PathArray Werkzeug kann auf 2D Formen verwendet werden, die mit der [[Draft Workbench/de|Entwurf Arbeitsbereich]] erstellt wurden, aber auch auf vielen Arten von 3D-Objekten, wie sie mit der [[Part Workbench/de|Part Arbeitsbereich]], [[PartDesign Workbench/de|PartDesign Arbeitsbereich]] oder [[Arch Workbench/de|Arch Arbeitsbereich]]en erstellt wurden.


To position copies in an orthogonal array use [[Draft Array|Draft Array]]; to position copies at specified points use [[Draft PointArray|Draft PointArray]]; to create copies or clones, and manually place them use [[Draft Move|Draft Move]], [[Draft Rotate|Draft Rotate]], and [[Draft Clone|Draft Clone]].
Um Kopien in einem orthogonalen Anordnung zu positionieren, verwende [[Draft Array/de|Entwurf Anordnung]]; um Kopien an bestimmten Punkten zu positionieren, verwende [[Draft PointArray/de|Entwurf PunktAnordnung]]; um Kopien oder Klone zu erstellen und diese manuell zu platzieren, verwende [[Draft Move/de|Entwurf Bewegen]], [[Draft Rotate/de|Entwurf Drehung]] und [[Draft Clone/de|Entwurf Klon]].


[[Image:Draft_PathArray_Example.png|400px]]
[[Image:Draft_PathArray_Example.png|400px]]

Revision as of 21:45, 16 January 2020

PfadDatenfeld

Menüeintrag
Entwurf → PfadDatenfeld
Arbeitsbereich
Draft, Arch
Standardtastenkürzel
Keiner
Eingeführt in Version
0.14
Siehe auch
Anordnung, Draft PointArray/de

Beschreibung

Das PfadFeld Werkzeug platziert Kopien einer ausgewählten Form entlang eines ausgewählten Pfades, die aus einem Entwurfsdraht, einem Draft BSpline und ähnlichen Kanten bestehen können.

Das PathArray Werkzeug kann auf 2D Formen verwendet werden, die mit der Entwurf Arbeitsbereich erstellt wurden, aber auch auf vielen Arten von 3D-Objekten, wie sie mit der Part Arbeitsbereich, PartDesign Arbeitsbereich oder Arch Arbeitsbereichen erstellt wurden.

Um Kopien in einem orthogonalen Anordnung zu positionieren, verwende Entwurf Anordnung; um Kopien an bestimmten Punkten zu positionieren, verwende Entwurf PunktAnordnung; um Kopien oder Klone zu erstellen und diese manuell zu platzieren, verwende Entwurf Bewegen, Entwurf Drehung und Entwurf Klon.

Object arranged along a path

Anwendung

  1. Select an object that you wish to distribute.
  2. Select a path object or some edges along which the object will be distributed.
  3. Press the Draft PathArray button.
  4. The Array object is immediately created. You must change the properties of the array to change the number and direction of copies created.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

The base object should be centred around the origin, even if the path starts somewhere else.

Optionen

Es gibt keine Optionen für dieses Werkzeug. Entweder funktioniert es mit den ausgewählten Objekten oder nicht.

Eigenschaften

  • DatenBase: specifies the object to duplicate in the path.
  • DatenPathObj: specifies the path object.
  • DatenPathSubs: specifies the sub-elements (edges) of the path object. This property does not yet appear in the property editor.
  • DatenCount: specifies the number of copies of the base object.
  • DatenAlign: if it is true the copies are aligned to the path; otherwise they are left in their default orientation.
Note: in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
  • DatenXlate: specifies a translation vector (x, y, z) to displace each copy along the path.
Note: when DatenAlign is true, the vector is relative to the local tangent, normal or binormal coordinates; otherwise the vector is relative to the global coordinates.

Scripting

Siehe auch: Draft API und FreeCAD Scripting Grundlagen.

The PathArray tool can be used in macros and from the Python console by using the following function:

PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
  • Creates a PathArray object from the baseobject, by placing as many as count copies along pathobject.
    • If pathobjsubs is given, it is a list of sub-objects of pathobject, and the copies are created along this shorter path.
  • If xlate is given, it is a FreeCAD.Vector that indicates an additional displacement to move the base point of the copies.
  • If align is True the copies are aligned to the tangent, normal or binormal of the pathobject at the point where the copy is placed.

Beispiel:

import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)

Technische Erklärung für die Ausrichteigenschaft

Align false
Align false

Objekt, das entlang eines geschlossenen Pfades in der ursprünglichen Ausrichtung angeordnet ist.

When DatenAlign is true, the positioning of the shapes becomes a bit more complex:

  1. First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
  2. Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.

Object arranged along a closed path; description of components and path

The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:

Object arranged along a closed path which is aligned to the XY plane

Path on XZ Plane:

Object arranged along a closed path which is aligned to the XZ plane

Path on YZ Plane:

Object arranged along a closed path which is aligned to the YZ plane

As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

Editor: thank you to user DeepSOIC for this explanation.